Oracle Coherence for C++ API
Release 3.6.1.0
E18813-01

- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# WrapperCollections::AbstractWrapperSet Class Reference

`#include <coherence/util/WrapperCollections.hpp>`

Inherits Object, and Set.

Inherited by ConverterCollections::ConverterSet, ReadOnlyMultiList::SetView, and TypedCollections::TypedSet.

List of all members.

## Detailed Description

Set implementation which delegates all calls to another Set.

## Public Types
typedef spec::Handle | Handle
| AbstractWrapperSet Handle definition.
typedef spec::View | View
| AbstractWrapperSet View definition.
typedef spec::Holder | Holder
| AbstractWrapperSet Holder definition.
## Public Member Functions
virtual size32_t | size () const
| Return the number of elements in this collection. Returns: the number of elements in this collection
virtual bool | isEmpty () const
| Determine whether this collection contains any elements. Returns: true if this collection has no elements
virtual bool | contains (Object::View v) const
  | Determine if this collection contains the specified element. Parameters:
  | v | the element to test for containment
Returns: true iff this collection contains the given element
virtual Iterator::Handle | iterator () const
| Return an Iterator over this collection. Returns: an Iterator over this collection
virtual Muterator::Handle | iterator ()
| Return an Iterator over this collection. Returns: an Iterator over this collection
virtual ObjectArray::Handle | toArray (ObjectArray::Handle hao=NULL) const
  | Return the contents of this collection as an ObjectArray. If the collection fits in the specified array, it is returned, otherwise, a new array is allocated that is the size of this collection. If this collection fits in the array with aditional room then the element in the array immediately following the end of the collection is set to NULL. This can be useful in determining the length of this collection if the caller knows that the collection does not contain any NULL elements. Parameters:
  | hao | an array in which to store the collection's contents
Returns: a ObjectArray containing all the elements of the collection in the same order as returned by the collection's Iterator See also: Iterator
virtual bool | add (Object::Holder oh)
  | Add the given element to this collection. Parameters:
  | oh | the element to add
Returns: true iff this collection was modified as a result of this operation
virtual bool | remove (Object::View v)
  | Remove the supplied element from this collection. Parameters:
  | v | the element to remove
Returns: true iff this collection was modified as a result of this operation
virtual bool | containsAll (Collection::View vc) const
  | Determine if this collection contains all elements from the supplied collection. Parameters:
  | vCol | the collection of elements to test for containment
  Returns: true iff this collection contains all elements from the supplied collection Exceptions:
  | coherence::lang::NullPointerException | if the specified collection is NULL
See also: contains()
virtual bool | addAll (Collection::View vc)
  | Add all elements from the supplied collection to this collection. Parameters:
  | vCol | the collection of elements to add
  Returns: true iff this collection was modified as a result of this operation Exceptions:
  | coherence::lang::NullPointerException | if the specified collection is NULL
See also: add()
virtual bool | removeAll (Collection::View vc)
  | Remove all instances of the elements in the supplied collection from this collection. Upon completion, contains() on this collection will return false for all elements in the supplied collection. Parameters:
  | vCol | the collection of elements to remove
  Returns: true iff this collection was modified as a result of this operation Exceptions:
  | coherence::lang::NullPointerException | if the specified collection is NULL
See also: remove() contains()
virtual bool | retainAll (Collection::View vc)
  | Remove all elements from this collection that are not present in the supplied collection. Parameters:
  | vCol | the collection of elements to retain
  Returns: true iff this collection was modified as a result of this operation. Exceptions:
  | coherence::lang::NullPointerException | if the specified collection is NULL
See also: remove() contains()
virtual void | clear ()
| Remove all elements from this collection.
virtual void | toStream (std::ostream &out) const
| Output a human-readable description of this Object to the given stream. coherence::lang::operator<<(std::ostream, Object::View) is defined and will call into the toStream method, to output Objects. If a managed String object is desired, the COH_TO_STRING macro can be used to build up a String from streamable contents.
     Object::View vKey   = ...
     Object::View vValue = ...
     std::cout << vKey << " = " << vValue << std::endl;

     String::Handle hs = COH_TO_STRING(vKey << " = " << vValue);
  Parameters:
  | out | the stream used to output the description
virtual size32_t | hashCode () const
| Return a hash code value for the Object. This method is supported for the benefit of hash-based containers. The general contract of `hashCode` is: Whenever it is invoked on the same Object more than once during an execution of an application, the `hashCode` method must consistently return the same value, provided no information used in `equals` comparisons on the object is modified. This value need not remain consistent from one execution of an application to another execution of the same application. If two Objects are equal according to the `equals` method, then calling the `hashCode` method on each of the two Objects must produce the same value. It is not required that if two Objects are unequal according to the `equals` method, then calling the `hashCode` method on each of the two objects must produce distinct results. However, the programmer should be aware that producing distinct results for unequal objects may improve the performance of hash-based containers. The default implementation is identity based. Returns: a hash code value for this Object
virtual bool | equals (Object::View v) const
virtual bool | isImmutable () const
| Return `true` iff no further changes can be made to the Object, that would effect the outcome of a call to its equals method. Except for Objects which are naturally immutable (such as String), being immutable generally implies that the Object is only referenced via const pointers or views. Objects which hold references to child Objects, may need to take the immutability of their children into account when determining their own immutability. This extended check is not performed by the default implementation, but can be integrated into the immutability checks by overriding this method, as well as making use of MemberHandles to reference child Objects. A typical derived implementation may look as follows:
     bool isImmutable() const
         {
         if (m_fImmutable) // check recorded state
             {
             return true; // already marked as immutable, avoid calculation
             }
         else if (Object::isImmutable()) // ensure shallow immutability
             {
             // ensure deep immutability
             if (m_child1->isImmutable() && m_child2->isImmutable() ...
                                         && m_childN->isImmutable())
                 {
                 // record and return immutability
                 return m_fImmutable = true;
                 }
             // some Objects which comprise this Object are still mutable
             }
         return false;
         }
The default implementation return true iff the Object is only referenced via const pointers and or views. Returns: true iff the Object is immutable
## Protected Member Functions
| AbstractWrapperSet (Set::Holder ohSetDelegate)
| Create an AbstractWrapperSet which delegates to the specified Set.
| AbstractWrapperSet (const AbstractWrapperSet &that)
| Copy constructor.
virtual Set::Handle | getDelegate ()
| Return a handle to the delegate.
virtual Set::View | getDelegate () const
| Return a view to the delegate.

## Constructor & Destructor Documentation

AbstractWrapperSet | ( | Set::Holder | ohSetDelegate | ) | `[protected]`

Create an AbstractWrapperSet which delegates to the specified Set.

Parameters:

  | ohSetDelegate | the Set to delegate to

## Member Function Documentation

virtual Set::Handle getDelegate | ( |  | ) | `[protected, virtual]`

Return a handle to the delegate.

Returns:
  the delegate handle

Exceptions:

  | UnsupportedOperationException | if the delegate is a view

virtual Set::View getDelegate | ( |  | ) | const`[protected, virtual]`

Return a view to the delegate.

Returns:
  the delegate view

The documentation for this class was generated from the following file:

- coherence/util/WrapperCollections.hpp

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.